
#if !defined(CONFIG_IP_NF_CONNTRACK) && \
    !defined(CONFIG_IP_NF_CONNTRACK_MODULE) && \
    !defined(CONFIG_NF_CONNTRACK) && \
    !defined(CONFIG_NF_CONNTRACK_MODULE)
#	error You need CONFIG_IP_NF_CONNTRACK enabled in your kernel configuration
#endif

#if !defined(CONFIG_IP_NF_CONNTRACK_MARK) && !defined(CONFIG_NF_CONNTRACK_MARK)
#	error You need CONFIG_IP_NF_CONNTRACK_MARK or CONFIG_NF_CONNTRACK_MARK enabled in your kernel configuration
#endif

#include <linux/skbuff.h>
#include <linux/types.h>
#include <linux/version.h>

#if defined(CONFIG_IP_NF_CONNTRACK) || defined(CONFIG_IP_NF_CONNTRACK_MODULE)
#	include <linux/netfilter_ipv4/ip_conntrack.h>
#else /* linux-2.6.20+ */
#	include <net/netfilter/nf_nat_rule.h>
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 20)
#    define nfmark mark
#endif

uint32_t test1(const struct sk_buff *skb)
{
	uint32_t ctstate;
	struct ip_conntrack *ctdata = ip_conntrack_get(skb, &ctstate);
	return ctdata->mark;
}

uint32_t test2(const struct sk_buff *skb)
{
	return skb->nfmark;
}
